---
html:
  toc: true
  offline: true
export_on_save:
  html: true
---
# KSB 툴박스 버전 업그레이드 하기(nvidia-docker버전)
---
KSB 툴박스 v19.03 nvidia-docker 버전을 업그레이드 하는 방법을 설명합니다.
본 메뉴얼은 v19.03.1 버전에서 v19.03.2 버전으로 업그레이드하는 경우를 예를들어 설명합니다.

## 설치 순서

Host PC에 KSB 툴박스를 설치하기 위해서 아래와 같은 절차로 설치합니다.
- [Host PC] KSB 툴박스 다운로드 및 압축 풀기
- [Host PC] KSB 툴박스 docker 이미지내 SSH 키를 host pc에 복사하기
- [Host PC] SSH 재시작하기
- [Host PC] ksb-csle 폴더 권한 변경하기
- [Host PC] KSB 툴박스 docker 컨테이너 실행하기

## [Host PC] KSB 프레임워크 설치 및 docker image 다운받기

업그레이드를 위해 새로운 KSB 툴박스 파일을 다운로드합니다.<a href="https://csleoss.etri.re.kr/images/contents/manual_1903/ksb_toolbox_nvidia_v1903.tar.gz" class="link_btn"> [다운로드 링크]</a>
  - ksb_toolbox_nvidia_v1903.tar.gz : KSB 툴박스 파일

기존 /home/csle/ksb-csle 폴더 이름을 변경합니다.
```sh
cd ~
mv ksb-csle ksb-csle-bak
```

csle 사용자 계정의 home에 ksb_toolbox_nvidia_v1903.tar.gz 압축을 해제합니다. 결과적으로 /home/csle/ksb-csle 폴더가 생성됩니다.

```sh
tar zxvf ksb_toolbox_nvidia_v1903.tar.gz -C /home/csle/
```

/home/csle/ksb-csle 폴더는 다음의 하위 폴더들로 구성됩니다.
  - /bin : KSB 프레임워크 shell 스크립트 파일 저장 폴더
  - /components : tensorflow train 예제 프로그램 저장 폴더
  - /conf : KSB 프레임워크 환경설정 파일 저장 폴더  
  - /docker : KSB 툴박스 docker 컨테이너 실행 스크립트 저장 폴더
  - /examples : CLI(Command Line Interface)를 통해 워크플로우 생성 및 submit 할 수 있는 프로젝트 폴더
  - /jars : KSB 프레임워크 19.03 버전의 jar 파일 저장 폴더
  - /ksblib : python 전처리 라이브러리 폴더
  - /kubernetes : 쿠버네티스 환경설정 폴더
  - /logs : log 저장 폴더
  - /pyML : autoML python 프로젝트 폴더
  - /tools: 예제 테스트를 위한 프로그램(jmeter, hadoop, kafka, maven, .ssh, webToolkit_db)
<br>

## [Host PC] KSB 툴박스 docker 이미지내 SSH 키를 host pc에 복사하기
KSB 툴박스 docker 컨테이너의 인증키를 공유하기 위해 ksb-csle/tools 폴더에 있는 .ssh 폴더를 csle 홈에 카피합니다.

```sh
cp -r ~/ksb-csle/tools/.ssh/ /home/csle/
```
authorized_keys를 다른 계정이 읽고 쓸 수 없게 600 mode(소유자만 rw 가능)로 변경합니다.
```sh
chmod 700 ~/.ssh
chmod 600 ~/.ssh/authorized_keys
```
**<span style="font-size: 10pt; color:red">[참고사항] 만약 보안을 위해 새로운 SSH 키를 Host PC와 docker 컨테이너가 공유할 수 있습니다.** <a href="https://csleoss.etri.re.kr/images/contents/manual_1903/2019-07-18-ssh_key_new_generation.html" title="SSH키 생성 및 공유하기">[바로가기] SSH키 생성 및 공유하기</a>

## [Host PC] SSH 재시작하기
```sh
sudo service ssh restart
```

## [Host PC] ksb-csle 폴더 권한 변경하기
KSB 툴박스 docker 컨테이너에서 Host PC의 ksb-csle 폴더를 엑세스 할 수 있도록 폴더 권한을 변경합니다.
```sh
sudo chmod 777 -R /home/csle/ksb-csle/
```

## [Host PC] KSB 툴박스 docker 컨테이너 실행하기

```cd /home/csle/ksb_csle/docker/19.03-host```로 이동합니다.
아래의 명령을 통해 KSB 툴박스 docker 컨테이너를 실행하고 접속합니다. **<span style="font-size: 10pt; color:red">
이때 새로운 KSB 툴박스 docker image를 docker hub로 부터 자동으로 다운 받습니다.**

```sh
csle@csle1:~/ksb-csle/docker/19.03-host$ ./startDockerCsle.sh
Error response from daemon: network csle_standalone not found
csle1
start csle1 slave container...
4918997cd2dac93fe0b52f3df3a45a46db6df1f3f052854061696695451d2f22
csle@csle1:/$
```

KSB 인공지능 프레임워크 실행하기 위해 <a href="https://csleoss.etri.re.kr/images/contents/manual_1903/1.5.HowToRunFirst-1903.html" title="KSB 인공지능 프레임워크 실행하기">KSB 인공지능 프레임워크 실행하기</a> 페이지로 이동하여 KSB 프레임워크를 구동합니다.
