---
html:
  toc: true
  offline: true
export_on_save:
  html: true
---

# 새로운 SSH 키 생성 및 KSB toolbox(docker image)와 공유 및 저장하는 방법

## [Host PC] pub 키 생성 및 authorized 키 생성, 권한 수정
```
ssh-keygen -t rsa
cat id_rsa.pub >> ~/.ssh/authorized_keys
chmod 700 ~/.ssh/authorized_keys
```
## [Host PC] KSB toolbox 실행 및 SSH 서비스 실행
```
csle@csle1:~/ksb-csle/docker/19.03-host$ ./startDockerCsle.sh
Error: No such network: csle_cluster
Error: No such network: csle_standalone
csle1
start csle1 slave container...
972d7615994fe86131c3ad4f97e783463dcc5d3148faea293eae0492040a0da2
csle@csle1:/$
```

## [Docker 컨테이너] SSH 서비스 실행
```
csle@csle1:/$ sudo service ssh start
 * Starting OpenBSD Secure Shell server sshd               [ OK ]
```
## [Host PC] SSH 키를 docker 컨테이너에 복사
```
scp ~/.ssh/id_rsa csle1:/home/csle/.ssh/id_rsa
scp ~/.ssh/id_rsa.pub csle1:/home/csle/.ssh/id_rsa.pub
scp ~/.ssh/authorized_keys csle1:/home/csle/.ssh/authorized_keys
```

## [Docker 컨테이너] Host PC에 ssh 명령으로 접속 확인
```
csle@csle1:/$ ssh -l csle csle1 -p 2243 sudo ls
Warning: Permanently added '[csle1]:2243,[129.254.173.227]:2243' (ECDSA) to the list of known hosts.
ksb-csle
공개
다운로드
문서
바탕화면
비디오
사진
음악
템플릿
```

## [Host PC] docker commit 이미지 저장
```
docker commit csle1 ksbframework/ksb_toolbox:19.03.3.1-miniconda3
```
## [Host PC] startDockerCsle.sh 파일에서 docker image tag 수정
